/*
	File:		SVAEAccessors.h

	Contains:	

	Written by: Original version by Jon Lansdell and Nigel Humphreys.
				3.1 updates by Greg Sutton.

	Copyright:	Copyright  1995-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/20/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/

#ifndef __SVAEACCESSORS__
#define __SVAEACCESSORS__

#include "SVToken.h"

#include <TextEdit.h>

OSErr			InstallAccessors(void);

pascal OSErr	WindowFromNullAccessor(DescType		wantClass,
										const AEDesc	*container,
										DescType  		containerClass,
										DescType		form, 
										const AEDesc	*selectionData,
										AEDesc			*value,
										long			theRefCon);

pascal OSErr	ApplicationFromNullAccessor(DescType		wantClass,
											const AEDesc	*container,
											DescType		containerClass,
											DescType		form, 
											const AEDesc	*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	TextElemFromTextAccessor(DescType			wantClass,
											AEDesc			*container,
											DescType		containerClass,
											DescType		form,
											AEDesc			*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	PropertyFromTextAccessor(DescType			wantClass,
											const AEDesc	*container,
											DescType		containerClass,
											DescType		form, 
											const AEDesc	*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	PropertyFromWndwAccessor(DescType			wantClass,
											AEDesc			*container,
											DescType		containerClass,
											DescType		form, 
											AEDesc			*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	PropertyFromNullAccessor(DescType			wantClass,
											AEDesc			*container,
											DescType		containerClass,
											DescType		form, 
											AEDesc			*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	PropertyFromListAccessor(DescType			wantClass,
											AEDesc			*container,
											DescType		containerClass,
											DescType		form, 
											AEDesc			*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	PropertyFromApplAccessor(DescType			wantClass,
											const AEDesc	*container,
											DescType		containerClass,
											DescType		form, 
											const AEDesc	*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	MenuFromNullAccessor(DescType			wantClass,
										const AEDesc	*container,
										DescType		containerClass,
										DescType		form, 
										const AEDesc	*selectionData,
										AEDesc			*value,
										long			theRefCon);

pascal OSErr	PropertyFromWinPropertyAccessor(DescType		wantClass,
												const AEDesc	*container,
												DescType		containerClass,
												DescType		form, 
												const AEDesc	*selectionData,
												AEDesc			*value,
												long			theRefCon);

pascal OSErr	PropertyFromMenuItemAccessor(DescType			wantClass,
												const AEDesc	*container,
												DescType		containerClass,
												DescType		form, 
												const AEDesc	*selectionData,
												AEDesc			*value,
												long			theRefCon);

pascal OSErr	MenuItemFromMenuAccessor(DescType			wantClass,
											const AEDesc	*container,
											DescType		containerClass,
											DescType		form, 
											const AEDesc	*selectionData,
											AEDesc			*value,
											long			theRefCon);

pascal OSErr	PropertyFromMenuAccessor(DescType			wantClass,
											const AEDesc	*container,
											DescType		containerClass,
											DescType		form, 
											const AEDesc	*selectionData,
											AEDesc			*value,
											long			theRefCon);

OSErr		WindowFormAbsolutePosition(const AEDesc	*selectionData, AEDesc* result);
OSErr		WindowFormName(const AEDesc	*selectionData, AEDesc* result);

OSErr		TextFormAbsolutePosition(TextToken* containerToken, AEDesc* selectionData,
													DescType wantClass, AEDesc* result);
OSErr		TextFormRange(TextToken* containerToken, AEDesc* selectionData,
													DescType wantClass, AEDesc* result);
OSErr		TextFormRelativePosition(TextToken* containerToken, AEDesc* selectionData,
													DescType wantClass, AEDesc* result);

OSErr		TokenListToPropertyList(AEDesc* tokenList, DescType aProperty, AEDesc* result);

#endif
