/*
	File:		SVEditAEUtils.h

	Contains:	

	Written by: Original version by Jon Lansdell and Nigel Humphreys.
							3.1 updates by Greg Sutton.	

	Copyright:	Copyright 1995-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/19/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/

#include <Types.h>
#include <Quickdraw.h>
#include <Packages.h>
#include <GestaltEqu.h>
#include <Editions.h>
#include <Printing.h>
#include <AppleEvents.h>
#include <ToolUtils.h>

#ifndef __SVEDITAEUTILS__
#define __SVEDITAEUTILS__

#include "SVToken.h"

	// Utility Routines for getting data from AEDesc's
	
void 	GetRawDataFromDescriptor(const AEDesc *theDesc, Ptr destPtr,
											Size destMaxSize, Size *actSize);
																		 
OSErr	GetPStringFromDescriptor(const AEDesc *aDesc, StringPtr resultStr);
OSErr	PutPStringToDescriptor(AEDesc* aDesc, StringPtr pStr);
OSErr	GetIntegerFromDescriptor(const AEDesc *sourceDesc, short *result);
OSErr	GetBooleanFromDescriptor(const AEDesc *sourceDesc, Boolean *result);
OSErr	GetLongIntFromDescriptor(const AEDesc *sourceDesc, long   *result);
OSErr	GetRectFromDescriptor(const AEDesc *sourceDesc, Rect *result);
OSErr	GetPointFromDescriptor(const AEDesc *sourceDesc, Point  *result);
OSErr	GetEnumeratedFromDescriptor(const AEDesc *sourceDesc, DescType  *result);

	// Parameter routines

OSErr		GotRequiredParams(const AppleEvent *theAppleEvent);
OSErr		AddResultToReply(AEDesc* result, AEDesc* reply, OSErr error);

	// Routine so events can be sent to self

OSErr		MakeSelfAddress(AEAddressDesc *selfAddress);


#endif