/*
	File:		SVEditGlobals.c

	Contains:	

	Written by: Original version by Jon Lansdell and Nigel Humphreys.
							3.1 updates by Greg Sutton.	

	Copyright:	Copyright 1995-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/19/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				10/12/95	CW				Added Metrowerks condition for "qd" definition.
						   					Added gHasDragManager flag, gDragTrackingHandlerUPP and
						   					gDragReceiveHandlerUPP Drag Manager UPPs (all globals).
*/


#define __COMPGLOBALS__

#include "SVEditGlobals.h"


#if defined(powerc) && !defined(__MWERKS__) // MetroWerks declares "qd" in their runtime
	QDGlobals	qd;
#endif


short      gWCount;
short      gNewDocCount;
MenuHandle myMenus[kLastMenu+1];
short      gFontMItem;
Boolean    gQuitting;
Cursor     editCursor;
Cursor     waitCursor;
Boolean    gInBackground;
  
  /*now for the environment variables set up by Gestalt*/
  
Boolean    gGestaltAvailable;
Boolean    gAppleEventsImplemented;
Boolean    gAliasManagerImplemented;
Boolean    gEditionManagerImplemented;
Boolean    gOutlineFontsImplemented;
Boolean    gRecordingImplemented;
Boolean    gHasDragManager;		/* Is the Drag Manager available? */


ControlActionUPP		gHScrollActionUPP;
ControlActionUPP		gVScrollActionUPP;
UserItemUPP				gDefaultButtonUPP;
DragTrackingHandlerUPP	gDragTrackingHandlerUPP;
DragReceiveHandlerUPP	gDragReceiveHandlerUPP;



