/*
	File:		FinderDragPro.r
	
	Description: 	Sample file illustrating drag and drop techniques for use
				with file system objects.  This file illustrates how applications
				can use drag and drop commands in a way compatible with current
				and past versions of the Finder.

	Author:		John Montbriand

	Copyright: 	Copyright:  1999 by Apple Computer, Inc.
				all rights reserved.
	
	Disclaimer:	You may incorporate this sample code into your applications without
				restriction, though the sample code has been provided "AS IS" and the
				responsibility for its operation is 100% yours.  However, what you are
				not permitted to do is to redistribute the source as "DSC Sample Code"
				after having made changes. If you're going to re-distribute the source,
				we require that you make it clear in the source that the code was
				descended from Apple Sample Code, but that you've made changes.
	
	Change History (most recent first):
	9/9/99 reworked and updated to most recent interfaces by John Montbriand
*/

#include "Processes.r"
#include "CodeFragments.r"
#include "Dialogs.r"
#include "Controls.r"

include "FinderDragPro.rsrc";

resource 'SIZE' (-1, purgeable)  {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	getFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	isStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	1024 * 300,
	1024 * 300
};

resource 'cfrg' (0) {
	{	kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsApp,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"FinderDragPro"
	}
};

resource 'dlgx' (128) {
	versionZero {
		kDialogFlagsUseThemeBackground | kDialogFlagsUseThemeControls
	}
};

resource 'dlgx' (130) {
	versionZero {
		kDialogFlagsUseThemeBackground | kDialogFlagsUseThemeControls
	}
};

/*
resource 'CNTL' (130) {
	{ 66, 19, 83, 196 },
	0,
	visible,
	100,
	0,
	kControlProgressBarProc,
	0,
	"file copy progress"
};

*/
