/*
	File:		PrivateConditionals.h

	Contains:	Conditional macro definitions that are used to setup the 
				environment for the project being built.
				Add any conditionals which are appropriate for your project.

	Written by: Andy Bachorski	

	Copyright:	Copyright  1996-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/21/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*//********************************************************************************

	File:		PrivateConditionals.h

	Contains:	
	File Ownership:	Apple Macintosh Developer Technical Support
	
	DRI:			
	
	Technology:		Project Control

	Package:		MoreAppleEvents
	
	Version:		1.0

	Copyright:	 1998 by Apple Computer, Inc., all rights reserved.


	========================================================================
	You may incorporate this sample code into your applications without
	restriction, though the sample code has been provided AS IS and the
	responsibility for its operation is 100% yours.  However, what you are
	not permitted to do is to redistribute the source as DSC Sample Code
	after having made changes. If youre going to re-distribute the source,
	we require that you make it clear in the source that the code was
	descended from Apple Sample Code, but that youve made changes.
	========================================================================

	Writers:

		(afb)	Andy Bachorski

	Change History (most recent first):

		<1>		12/16/98	afb		First pass
		
********************************************************************************/

#if PRAGMA_ONCE
	#pragma once
#endif

#ifndef _PRIVATE_CONDITIONALS_
#define _PRIVATE_CONDITIONALS_

/*
 *	To allow the use of ToolBox calls which have now become obsolete on PowerPC, but
 *	which are still needed for System 6 applications, we need to #define OBSOLETE.  If
 *	Since we won't be using these calls, define this to 0 (false).
 */

#define OBSOLETE	0

/*
 *	Define the following conditionals appropriately so the project is compiled
 *	using only the latest routines.
 */
 
#define SystemSevenOrLater			1
#define OLDROUTINENAMES				0
#define OLDROUTINELOCATIONS			0
#define HANDLE_ALL_REQUIRED_EVENTS	0
#define OBSOLETE					0


/*
 *	For this project we use the following macro to
 *	turn on or off the use of precompiled headers.
 */

#define USE_PRECOMPILED_HEADERS	FALSE



#endif // _PRIVATE_CONDITIONALS_
