/*
	File:		VersionInfo.r

	Contains:	Resources used to add version info to the project.

	Written by: Andy Bachorski	

	Copyright:	Copyright  1996-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/21/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/

#include "SysTypes.r"
#include "Types.r"

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#define kMajorVersNumber	0x01
#define kMinorVersNumber	0x00
#define kReleaseStage		final
#define kNonFinalRelease	0x00
#define kVersString			"1.0"

#define kRegionCode			verUS


resource 'vers' (1) {
	kMajorVersNumber,
	kMinorVersNumber,
	kReleaseStage,
	kNonFinalRelease,
	kRegionCode,
	kVersString,
	" 1996-1999 Apple Computer, Inc.\n" kVersString ", By Andy Bachorski, DTS"
};

resource 'vers' (2) {
	kMajorVersNumber,
	kMinorVersNumber,
	kReleaseStage,
	kNonFinalRelease,
	kRegionCode,
	kVersString,
	"MoreAppleEvents " kVersString
};

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

resource 'STR#' (1, "Product") {		//	as defined in VersionEdit from Teknosys
	{
		"MoreAppleEvents",		//	Product Name
		"",	//	File Name
		"1996-1998",		//	Release Year
		"",		//	Web Page
		""		//	FTP Directory
	}
};

resource 'STR#' (2, "Vendor") {		//	as defined in VersionEdit from Teknosys
	{
		"Developer Technical Support",				//	Author
		"Apple Computer, Inc.",						//	Company
		"1 Infinite Loop\nCopertino, CA  95014",	//	Address
		"",		//	Phone
		"",		//	Fax
		"",		//	AOL address
		"",		//	CompuServe address
		"",		//	Internet eMail
		"devbugs@apple.com",				//	Web Site
		"http://devworld.apple.com/",		//	FTP Directory
		""
	}
};

#define prodDesc "ProductInfo"
read 'STR ' (1, prodDesc) prodDesc;				//	as defined in VersionEdit from Teknosys

