/*
	File:		MoreDialogs.h

	Contains:	

	Written by:	Pete Gontier

	Copyright:	Copyright (c) 1998 Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <6>     20/3/00    Quinn   Fix prototype for GetDialogItemString.
         <5>     1/22/99    PCG     TARGET_CARBON
         <4>      1/7/99    PCG     add ToggleDialogItemCheckBox
         <3>      1/7/99    PCG     add MoreAppendDialogItemList
         <2>    11/11/98    PCG     fix headers
         <1>    11/10/98    PCG     first big re-org at behest of Quinn

	Old Change History (most recent first):

         <7>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
         <6>      9/9/98    PCG     re-work import and export pragmas
         <5>      9/1/98    PCG     Universal Headers 3.2
         <4>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <3>     7/24/98    PCG	    add MoveableModalDialog
         <2>     7/24/98    PCG	    eliminate dependency on 'qd'
         <1>     6/16/98    PCG     initial checkin
*/

#pragma once

#include "MoreSetup.h"

#include <Dialogs.h>

enum { kDialogItemIndexNone = -1 };

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

#if UNIVERSAL_INTERFACES_VERSION < 0x0320

	extern pascal OSErr AppendDialogItemList (DialogPtr dialog, SInt16 ditlID, DITLMethod method)
		THREEWORDINLINE (0x303C, 0x0412, 0xAA68);

#endif // UNIVERSAL_INTERFACES_VERSION < 0x0320

pascal void			SaferShortenDITL			(DialogPtr, DialogItemIndex);
pascal DialogPtr	MoreGetNewDialog			(short dlogResID);
pascal void			SetDialogItemString			(DialogPtr, DialogItemIndex, ConstStringPtr);
pascal void			GetDialogItemString			(DialogPtr, DialogItemIndex, Str255);
pascal void			SelectAllDialogItemText		(DialogPtr, DialogItemIndex);
pascal void			MoveableModalDialog			(ModalFilterUPP, short *itemHit);
pascal Boolean		ToggleDialogCheckBox		(DialogPtr, DialogItemIndex);
pascal OSErr		MoreAppendDialogItemList	(DialogPtr, DialogItemIndex, DITLMethod);

#pragma import reset // for clients
#pragma export reset // for building a library

#if !TARGET_CARBON
#	define SetPortDialogPort(x)		SetPort(x)
#	define GetDialogFromWindow(x)	(x)
#endif

#ifdef __cplusplus
	}
#endif
