/*
	File:		TestMoreOSLTerminology.h

	Contains:	Constants shared between C and Rez

	Written by:	Quinn

	Copyright:	Copyright  2000 by Apple Computer, Inc., all rights reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):

         <2>     20/3/00    Quinn   Comments and various fixes.
         <1>      6/3/00    Quinn   First checked in.
*/

#pragma once

/////////////////////////////////////////////////////////////////

// The creator 'MOSL' has been registered with DTS for this sample.
// I use it in two key places.  Firstly, the test application uses it
// as its creator code.  Secondly, MOSLStringCompare uses it (in the non-Carbon
// implementation) as the class ID of events that it sends to the comparison
// script.  The second use is hardwired to 'MOSL' (because the script
// is compiled that way).  The first use you can change by changing the
// constant below.

#define kMyCreator 			'MOSL'
#define kMyAESuite			kMyCreator

// application properties

#define pMyDebug			'MDBG'
#define pMyNextUniqueID     'MNUI'
#define pMyFileValid		'MFLV'
	// All of these properties have explanator comments in
	// the file "TestMoreOSLTerminology.r".
		
// custom classes

#define cNodeWindow				'NWIN'
#define cAboutWindow			'AWIN'
	// Both of these are subclasses of window.
	
#define cNode					'CNDE'
	// Elements of a node window.

// properties of cDocument

#define pMyNodeDisplay			'NDSP'
#define pMyLocationOnDisk		'MLOC'

// properties of cAboutWindow

#define pMyCredits				'CRD'
